*
      SUBROUTINE CAL_GEEV1N(N, NPROW,NPCOL, AMEM, MEMSIZE, NB,
     $                      INFILEA, OUTFILE, TFILE,  NPRT, CTXT)
*
*      (PDGEEV1)
*      
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROW, NPCOL, NB, MEMSIZE,
     $                   NPRT, CTXT
      DOUBLE PRECISION   AMEM( MEMSIZE )
      CHARACTER*(*)      INFILEA, OUTFILE, TFILE
*
*   -  
      INTEGER            NOUT, NIN, NPR
      PARAMETER          ( NOUT1 = 12, NOUT = 13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            HBL, I, IAM, INFO, IPA, IPWE, IPWI,
     $                   IPW, IPWOR, IPIWOR, ILO, IHI, ILOZ, IHIZ,
     $                   ILROW, ILCOL, IHIP, IHLP, INLQ, IOFF,
     $                   IA, JA, IAFIRST, JAFIRST, JJ, IIA, JJA,
     $                   IAROW, IACOL,
     $                   NP, NQ, M, MYCOL, MYROW, MXNP, MXNQ,
     $                   LDA, LWMIN, LWORK1, LWORK, LOCALK,
     $                   LCMRC, NPROCS, NPS, MMIN, WORKSIZ
*
*
*  
      INTEGER            DESCA( 9 )
      DOUBLE PRECISION   time, time1, time2
*
      COMMON             time, J
*
*  
      INTEGER            ICEIL, ILCM, NUMROC, MAX
      EXTERNAL           ICEIL, ILCM, NUMROC
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDLAPRNT, PDLAREAD,
     $                   PDLAWRITE, INFOG2L, INDXG2P, MINTGEEV1,
     $                   PDGEEV1
*
*  
      INTRINSIC          ABS, DBLE, MAX, MIN, MOD, SQRT, INT
*
*  
*
*  
*
      IA = 1
      JA = 1
*
      ILO = 1
      IHI = N
      ILOZ = 1
      IHIZ = N
*
*    BLACS'    
*
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
       NP = NUMROC( N, NB, MYROW, 0, NPROW )
       NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
*
*      A
*
      CALL DESCINIT(DESCA, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
*
*     AMEM
*
*     A
      IPA = 1
*
*     WE (  
* )
      IPWE = IPA + DESCA(9)*NQ
*
*     WI (   )
      IPWI = IPWE + N
*
*     WORK
      IPWOR = IPWI + N
*     W
*
         CALL INFOG2L( IA, JA, DESCA, NPROW, NPCOL, MYROW, MYCOL,
     $                 IIA, JJA, IAROW, IACOL )
         IHIP = NUMROC( IHI, NB, MYROW, IAROW, NPROW )
         IOFF = MOD( IA+ILO-2, NB )
         ILROW = INDXG2P( IA+ILO-1, NB, MYROW, 0, NPROW )
         IHLP = NUMROC( IHI-ILO+IOFF+1, NB, MYROW, ILROW, NPROW )
         ILCOL = INDXG2P( JA+ILO-1, NB, MYCOL, 0, NPCOL )
         INLQ = NUMROC( N-ILO+IOFF+1, NB, MYCOL, ILCOL, NPCOL )
         LWMIN = NB*( NB + MAX( IHIP+1, IHLP+INLQ ) )
*
         AMEM(IPWOR) = DBLE( LWMIN )
         LWORK  = LWMIN
*
*   ,    PDGEEV1
*
      HBL = DESCA( 6 )
      LDA = DESCA( 9 )
      IAFIRST = DESCA( 7 )
      JAFIRST = DESCA( 8 )
      LCMRC = ILCM( NPROW, NPCOL )
*
*    ,    
*  
*
      LOCALK = NUMROC( N, HBL, MYCOL, JAFIRST, NPCOL )
      JJ = N / HBL
      IF( JJ*HBL.LT.N )
     $   JJ = JJ + 1
      JJ = 7*JJ / LCMRC
      LWORK1 = 3*N+MAX( 2*LDA + 2*LOCALK, JJ )
*
      IF( LWORK .LT. LWORK1 ) THEN
        AMEM(IPWOR) = DBLE( LWORK1 )
        LWORK = LWORK1
      END IF
*
      IPW = IPWOR + LWORK
*
      GOTO 3
*
*     PDLAPRNT  .
*
    3 WORKSIZ = MAX( NB, NP )
*
*        
*
      INFO = 0
      MMIN = IPW + WORKSIZ
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 )
     $       WRITE( NOUT, FMT = * ) '   '
         GO TO 10
      END IF
*
*   ( )     A
*
      IF( INFILEA .EQ. ' ' ) THEN
         CALL MINTGEEV1( N, AMEM(IPA), DESCA, INFO )
      ELSE
         CALL PDLAREAD(INFILEA, AMEM(IPA), DESCA, 0, 0, AMEM(IPW))
      END IF
*
*    
      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1 .OR. NPRT .EQ. 2 ) GO TO 8
      IF( J .NE. 1 ) GO TO 8
*
*      
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )
         WRITE( NPR, FMT = 9998 )N, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * ) '     '
         WRITE( NPR, FMT = * )'  IPA,  IPWE, IPWI, IPWOR,  IPW, MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPWE, IPWI, IPWOR, IPW, MMIN
*
         WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
**         WRITE( NPR, FMT = 9993 )LWMIN, LWORK, LWORK1
         WRITE( NPR, FMT = * ) '  A'
      END IF
*
 9994 FORMAT( / 6I9 /)
 9985 FORMAT( / 9I5 /)
*
      CALL PDLAPRNT( N, N, AMEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
*
    8 CONTINUE
*
*       
*
**      IF( NAME .NE. 'PDGEEV1' ) GOTO 10
*
      time1 = MPI_Wtime()
*
      CALL PDGEEV1( N, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPWE), AMEM(IPWI), AMEM(IPWOR), LWORK, INFO )
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
 9999 FORMAT( /' (Wtime) =', D14.3, ' time1 =', D12.3,
     $        ' time2 =', D14.3 )
*
      GOTO 99
*
   99 CONTINUE
*
*   
*
      IF( J .NE. 1 .AND. J .NE. 2000 ) GO TO 25
      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1 ) GO TO 28
*
*  
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         WRITE( NPR, FMT = 9996 )INFO
***         WRITE( NPR, FMT = 9993 )AMEM(IPWOR)
   14   WRITE( NPR, FMT = * ) '  '
*
         DO 18 I = IPWE, IPWE+N-1
         PRINT *, ' WE(', I-IPWE+1, ')=', AMEM( I ), ';'
   18   CONTINUE
*
         WRITE( NPR, FMT = 9990 )
*
         DO 23 I = IPWI, IPWI+N-1
         PRINT *, ' WI(', I-IPWI+1, ')=', AMEM( I ), ';'
   23   CONTINUE
      END IF
*
 9993 FORMAT( / 4I9 /)
 9990 FORMAT( / )
*
   28 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
        WRITE( NPR, FMT = * )' : ', MMIN, MEMSIZE, J
      END IF
   25 CONTINUE
*
*        
*  ,      ' '.
*
      IF( OUTFILE .EQ. ' ' ) GO TO 30
*
*     
*
      IF( J .NE. 1 ) GO TO 30
**      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1 ) GO TO 30
*
   19 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         WRITE(NOUT, FMT = *)'   '
         WRITE(NOUT, FMT = *)' '
*
         WRITE(NOUT, FMT = *) N, 1
         DO 27 I = 1, N
            WRITE( NOUT, FMT = * ) AMEM( IPWE+I-1 )
   27    CONTINUE
*
         WRITE( NPR, FMT = 9990 )
*
   22    WRITE(NOUT, FMT = *) N, 1
         DO 29 I = 1, N
            WRITE( NOUT, FMT = * ) AMEM( IPWI+I-1 )
   29    CONTINUE
*
      END IF
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
   30 CONTINUE
*
*       
*   ,  
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
*
        IF( J .NE. 1 ) GO TO 31
*
          WRITE( NOUT1, FMT = * )' : ', MMIN, MEMSIZE, J
*
   31   WRITE( NOUT1, FMT = 2001 ) NPROW, NPCOL, NB, time
*
**         WRITE( NOUT1, FMT = 9999 )time, time1, time2
      END IF
*
   10 CONTINUE
*
   20 CONTINUE
*
      IF( IAM .EQ. 0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
 2001 FORMAT( 3I5, D14.3/ )
*
 9992 FORMAT( / '   PDGEEV1' )
 9998 FORMAT(/'     ,',//,
     $       '  A -    ',I5,'  ',I5,',',
     $       /'         ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I3, ' ,',
     $       '    ', I2, '  ', I2 /)
* 9995 FORMAT( / '  INFO =', I6/)
 9996 FORMAT( / '  INFO  = ', I6 /)
      RETURN
      END
